<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Louvain Algorithm: src/community.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Louvain Algorithm
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">community.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="community_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> ============================================================================</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> Name        : community.h</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> Author      : Buratto Alessandro</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> ============================================================================</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="graph_8h.html">graph.h</a>&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="linkedlist_8h.html">linkedlist.h</a>&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifndef COMMUNITY_H_</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#define COMMUNITY_H_</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="structcommunity__t.html#ac0fef4f0ce4389e2d3578e85588a83d8">   20</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structcommunity__t.html">community_t</a> {<span class="keywordtype">int</span> <a class="code" href="structcommunity__t.html#a75da2d3d0f07ca29dde65268ae4cf88a">internal_weight</a>, <a class="code" href="structcommunity__t.html#ad5139bd32f99d7634c308ddf13ce1c6b">external_weight</a>, <a class="code" href="structcommunity__t.html#ac0fef4f0ce4389e2d3578e85588a83d8">num_nodes</a>; <a class="code" href="structnode__t.html">node_t</a> * <a class="code" href="structcommunity__t.html#ae0af7db305b8b53967d8b9bdf70fa6c1">nodes</a>;} <a class="code" href="community_8h.html#a812795ce94970c9dbbe7799f50e344a4">community_t</a>;</div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="structcommunity__set__t.html#ace8677db03be7e2a18dcb539cadd2366">   21</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="structcommunity__set__t.html">community_set_t</a> {<a class="code" href="structcommunity__t.html">community_t</a> * c; <a class="code" href="structgraph__t.html">graph_t</a> * g; <span class="keywordtype">int</span> <a class="code" href="structcommunity__set__t.html#ace8677db03be7e2a18dcb539cadd2366">num_communities</a>;} <a class="code" href="community_8h.html#a60b5b2abb28ce7a36d026d0187f882d8">community_set_t</a>;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<a class="code" href="structcommunity__set__t.html">community_set_t</a> * <a class="code" href="community_8h.html#a78f31c0399e157c4829c634e9762b3fa">create_community_set</a>(<a class="code" href="structgraph__t.html">graph_t</a> * graph);</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keywordtype">void</span> <a class="code" href="community_8h.html#a681b759eb1056a6cccd60161b6a2749a">add_node_to_community</a>(<a class="code" href="structcommunity__set__t.html">community_set_t</a> * <span class="keyword">set</span>, <span class="keywordtype">int</span> comm_index, <span class="keywordtype">int</span> node_id);</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keywordtype">void</span> <a class="code" href="community_8h.html#ad4e025b0ff4789827ae2aaf070c6393a">remove_node_from_community</a>(<a class="code" href="structcommunity__set__t.html">community_set_t</a> * <span class="keyword">set</span>, <span class="keywordtype">int</span> comm_index, <span class="keywordtype">int</span> node_id);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keywordtype">char</span> * <a class="code" href="community_8h.html#a3c0f99f4ab68ac8f7fb0fdbf7953bc06">neighboring_commuities</a>(<a class="code" href="structcommunity__set__t.html">community_set_t</a> * <span class="keyword">set</span>, <span class="keywordtype">int</span> comm_index);</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keywordtype">int</span> <a class="code" href="community_8h.html#ad774ff0f64931b2a26dd56014014f6c0">find_community</a>(<a class="code" href="structcommunity__set__t.html">community_set_t</a> * <span class="keyword">set</span>, <span class="keywordtype">int</span> target);</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keywordtype">int</span> <a class="code" href="community_8h.html#a055e81a3e6d9f9faf71343c2db4703a7">possible_new_links</a>(<a class="code" href="structcommunity__set__t.html">community_set_t</a> * <span class="keyword">set</span>, <span class="keywordtype">int</span> comm_index, <span class="keywordtype">int</span> node_id);</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keywordtype">double</span> <a class="code" href="community_8h.html#a97f471d6cfb2b90ba69089988d9e7efe">modularity</a>(<a class="code" href="structcommunity__set__t.html">community_set_t</a> * <span class="keyword">set</span>);</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="keywordtype">void</span> <a class="code" href="community_8h.html#a5be1f3cb5477970bdd9ebc04801f407b">collapse</a>(<a class="code" href="structcommunity__set__t.html">community_set_t</a> * <span class="keyword">set</span>);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keywordtype">void</span> <a class="code" href="community_8h.html#a8e3b186f3dcd7d9760f05ed6f1723753">clean_set</a>(<a class="code" href="structcommunity__set__t.html">community_set_t</a> * <span class="keyword">set</span>);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="keywordtype">void</span> <a class="code" href="community_8h.html#a194dd56a0aa66d67628938e9b0bbff29">print_communities</a>(<a class="code" href="structcommunity__set__t.html">community_set_t</a> * <span class="keyword">set</span>);</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMMUNITY_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="structnode__t_html"><div class="ttname"><a href="structnode__t.html">node_t</a></div><div class="ttdef"><b>Definition:</b> linkedlist.h:15</div></div>
<div class="ttc" id="structcommunity__t_html_ae0af7db305b8b53967d8b9bdf70fa6c1"><div class="ttname"><a href="structcommunity__t.html#ae0af7db305b8b53967d8b9bdf70fa6c1">community_t::nodes</a></div><div class="ttdeci">node_t * nodes</div><div class="ttdef"><b>Definition:</b> community.h:20</div></div>
<div class="ttc" id="community_8h_html_a97f471d6cfb2b90ba69089988d9e7efe"><div class="ttname"><a href="community_8h.html#a97f471d6cfb2b90ba69089988d9e7efe">modularity</a></div><div class="ttdeci">double modularity(community_set_t *set)</div><div class="ttdef"><b>Definition:</b> community.c:224</div></div>
<div class="ttc" id="community_8h_html_a681b759eb1056a6cccd60161b6a2749a"><div class="ttname"><a href="community_8h.html#a681b759eb1056a6cccd60161b6a2749a">add_node_to_community</a></div><div class="ttdeci">void add_node_to_community(community_set_t *set, int comm_index, int node_id)</div><div class="ttdef"><b>Definition:</b> community.c:111</div></div>
<div class="ttc" id="structcommunity__set__t_html_ace8677db03be7e2a18dcb539cadd2366"><div class="ttname"><a href="structcommunity__set__t.html#ace8677db03be7e2a18dcb539cadd2366">community_set_t::num_communities</a></div><div class="ttdeci">int num_communities</div><div class="ttdef"><b>Definition:</b> community.h:21</div></div>
<div class="ttc" id="structcommunity__t_html_ac0fef4f0ce4389e2d3578e85588a83d8"><div class="ttname"><a href="structcommunity__t.html#ac0fef4f0ce4389e2d3578e85588a83d8">community_t::num_nodes</a></div><div class="ttdeci">int num_nodes</div><div class="ttdef"><b>Definition:</b> community.h:20</div></div>
<div class="ttc" id="linkedlist_8h_html"><div class="ttname"><a href="linkedlist_8h.html">linkedlist.h</a></div></div>
<div class="ttc" id="community_8h_html_a3c0f99f4ab68ac8f7fb0fdbf7953bc06"><div class="ttname"><a href="community_8h.html#a3c0f99f4ab68ac8f7fb0fdbf7953bc06">neighboring_commuities</a></div><div class="ttdeci">char * neighboring_commuities(community_set_t *set, int comm_index)</div><div class="ttdef"><b>Definition:</b> community.c:153</div></div>
<div class="ttc" id="community_8h_html_a60b5b2abb28ce7a36d026d0187f882d8"><div class="ttname"><a href="community_8h.html#a60b5b2abb28ce7a36d026d0187f882d8">community_set_t</a></div><div class="ttdeci">struct community_set_t community_set_t</div></div>
<div class="ttc" id="community_8h_html_ad774ff0f64931b2a26dd56014014f6c0"><div class="ttname"><a href="community_8h.html#ad774ff0f64931b2a26dd56014014f6c0">find_community</a></div><div class="ttdeci">int find_community(community_set_t *set, int target)</div><div class="ttdef"><b>Definition:</b> community.c:172</div></div>
<div class="ttc" id="community_8h_html_a194dd56a0aa66d67628938e9b0bbff29"><div class="ttname"><a href="community_8h.html#a194dd56a0aa66d67628938e9b0bbff29">print_communities</a></div><div class="ttdeci">void print_communities(community_set_t *set)</div><div class="ttdef"><b>Definition:</b> community.c:294</div></div>
<div class="ttc" id="graph_8h_html"><div class="ttname"><a href="graph_8h.html">graph.h</a></div></div>
<div class="ttc" id="community_8h_html_a5be1f3cb5477970bdd9ebc04801f407b"><div class="ttname"><a href="community_8h.html#a5be1f3cb5477970bdd9ebc04801f407b">collapse</a></div><div class="ttdeci">void collapse(community_set_t *set)</div><div class="ttdef"><b>Definition:</b> community.c:241</div></div>
<div class="ttc" id="community_8h_html_ad4e025b0ff4789827ae2aaf070c6393a"><div class="ttname"><a href="community_8h.html#ad4e025b0ff4789827ae2aaf070c6393a">remove_node_from_community</a></div><div class="ttdeci">void remove_node_from_community(community_set_t *set, int comm_index, int node_id)</div><div class="ttdef"><b>Definition:</b> community.c:131</div></div>
<div class="ttc" id="structcommunity__t_html"><div class="ttname"><a href="structcommunity__t.html">community_t</a></div><div class="ttdef"><b>Definition:</b> community.h:20</div></div>
<div class="ttc" id="structcommunity__set__t_html"><div class="ttname"><a href="structcommunity__set__t.html">community_set_t</a></div><div class="ttdef"><b>Definition:</b> community.h:21</div></div>
<div class="ttc" id="community_8h_html_a055e81a3e6d9f9faf71343c2db4703a7"><div class="ttname"><a href="community_8h.html#a055e81a3e6d9f9faf71343c2db4703a7">possible_new_links</a></div><div class="ttdeci">int possible_new_links(community_set_t *set, int comm_index, int node_id)</div><div class="ttdef"><b>Definition:</b> community.c:194</div></div>
<div class="ttc" id="community_8h_html_a812795ce94970c9dbbe7799f50e344a4"><div class="ttname"><a href="community_8h.html#a812795ce94970c9dbbe7799f50e344a4">community_t</a></div><div class="ttdeci">struct community_t community_t</div></div>
<div class="ttc" id="structgraph__t_html"><div class="ttname"><a href="structgraph__t.html">graph_t</a></div><div class="ttdef"><b>Definition:</b> graph.h:25</div></div>
<div class="ttc" id="community_8h_html_a8e3b186f3dcd7d9760f05ed6f1723753"><div class="ttname"><a href="community_8h.html#a8e3b186f3dcd7d9760f05ed6f1723753">clean_set</a></div><div class="ttdeci">void clean_set(community_set_t *set)</div><div class="ttdef"><b>Definition:</b> community.c:278</div></div>
<div class="ttc" id="structcommunity__t_html_a75da2d3d0f07ca29dde65268ae4cf88a"><div class="ttname"><a href="structcommunity__t.html#a75da2d3d0f07ca29dde65268ae4cf88a">community_t::internal_weight</a></div><div class="ttdeci">int internal_weight</div><div class="ttdef"><b>Definition:</b> community.h:20</div></div>
<div class="ttc" id="community_8h_html_a78f31c0399e157c4829c634e9762b3fa"><div class="ttname"><a href="community_8h.html#a78f31c0399e157c4829c634e9762b3fa">create_community_set</a></div><div class="ttdeci">community_set_t * create_community_set(graph_t *graph)</div><div class="ttdef"><b>Definition:</b> community.c:72</div></div>
<div class="ttc" id="structcommunity__t_html_ad5139bd32f99d7634c308ddf13ce1c6b"><div class="ttname"><a href="structcommunity__t.html#ad5139bd32f99d7634c308ddf13ce1c6b">community_t::external_weight</a></div><div class="ttdeci">int external_weight</div><div class="ttdef"><b>Definition:</b> community.h:20</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
